<div data-testid="filter-component" class="position-relative">
    <ng-container *transloco="let t; prefix: ''">
      <button data-testid="filter-menu-toggle" mat-button [matMenuTriggerFor]="menu">
        <mat-icon class="me-1">sort</mat-icon>
        {{ filledFields > 1 ? t('filters.titlePlural') : t('filters.title') }}
        @if (filledFields > 0 && selectedFiltersLabel) {
          ({{filledFields}}):
        }
      </button>
      @if (selectedFiltersLabel) {
        <span>{{selectedFiltersLabel}}</span>
      }

      <mat-menu #menu="matMenu" class="p-3 w-auto" (closed)="filter()">
        <div>
          <mat-form-field class="w-100" appearance="outline" (click)="$event.stopPropagation();" (keydown.enter)="$event.stopPropagation();">
            <mat-select [(ngModel)]="filterValue" [placeholder]="t('filters.selectColumn')">
              @for (o of options(); track o) {
                <mat-option [value]="o.value">{{t(o.label)}}</mat-option>
              }
            </mat-select>
          </mat-form-field>
        </div>
          @if (inputSelected(); as input) {
            @if (isInputText(input.input); as input) {
              <div>
                <mat-form-field class="w-100" appearance="outline" (click)="$event.stopPropagation();" (keydown.enter)="$event.stopPropagation();">
                  <input data-testid="input-field" matInput [formControl]="input.controller" type="text" (change)="inputChange()">
                </mat-form-field>
              </div>
            }
            @if (isDateFilter(input.input); as input) {
              <div data-testid="date-field">
                <mat-form-field>
                  <mat-label>Choose a date</mat-label>
                  <input matInput [matDatepicker]="picker" [formControl]="input.controller">
                  <mat-hint>MM/DD/YYYY</mat-hint>
                  <mat-datepicker-toggle matIconSuffix [for]="picker"></mat-datepicker-toggle>
                  <mat-datepicker #picker></mat-datepicker>
                </mat-form-field>
              </div>
            }
            @if (isDateRangeFilter(input.input); as input) {
              <div data-testid="date-range-field">
                <mat-form-field (click)="$event.stopPropagation();" (keydown.enter)="$event.stopPropagation();">
                  <mat-label>Choose a date range</mat-label>
                  <mat-date-range-input [rangePicker]="rangepicker">
                    <input matStartDate
                      [formControl]="input.controllerFrom"
                      placeholder="Start date">
                    <input matEndDate
                      [formControl]="input.controllerTo"
                      placeholder="End date">
                  </mat-date-range-input>
                  <mat-hint>MM/DD/YYYY – MM/DD/YYYY</mat-hint>
                  <mat-datepicker-toggle matIconSuffix [for]="rangepicker"></mat-datepicker-toggle>
                  <mat-date-range-picker #rangepicker></mat-date-range-picker>
                </mat-form-field>
              </div>
            }
            @if (isInputOption(input.input); as inputInput) {
              <div data-testid="options-field">
                <mat-form-field class="w-100" appearance="outline" (click)="$event.stopPropagation();" (keydown.enter)="$event.stopPropagation();">
                  <mat-select [formControl]="inputInput.controller" (selectionChange)="inputChange()">
                    <mat-option>None</mat-option>
                    @for (option of inputInput.options; track option) {
                      <mat-option [value]="option.value">{{ option.label }}</mat-option>
                    }
                  </mat-select>
                </mat-form-field>
              </div>
            }
          }
          <div class="d-flex flex-row justify-content-start gap-3 align-items-center">
            <button data-testid="reset-button" mat-flat-button color="secondary" (click)="reset()">{{ t('filters.reset') }}</button>
            <button data-testid="submit-button" mat-flat-button color="accent" (click)="filter()">{{ t('filters.apply') }}</button>
          </div>
      </mat-menu>
    </ng-container>
  </div>

